<template>
    <v-app v-if="loaded">
        <v-navigation-drawer
            v-model="drawer"
            width="200"
            app
        >
            <v-list-item class="fixed-height logo">
                <v-list-item-content>
                    <v-list-item-title>
                        <v-img class="mx-auto" src="/images/dashboard/h2u.png"></v-img>
                    </v-list-item-title>
                </v-list-item-content>
            </v-list-item>

            <v-divider></v-divider>

            <nav-menu></nav-menu>
        </v-navigation-drawer>

        <v-app-bar
            class="primary app-bar"
            flat
            absolute
            app
        >
            <v-app-bar-nav-icon color="white" @click.stop="drawer = !drawer"></v-app-bar-nav-icon>
            <v-spacer></v-spacer>

            <div class="pr-2">
                <v-locale-select></v-locale-select>
            </div>

            <account-menu></account-menu>
        </v-app-bar>

        <v-main class="secondary">
            <div class="app-bg"></div>
            <v-container :class="containerClass" fluid>
                <router-view v-if="loaded"></router-view>
            </v-container>
            <v-snackbar
                v-model="snackbar"
                :color="color"
                :timeout="timeout"
                top
                right
            >
                {{ message }}

                <template v-slot:action="{ attrs }">
                    <v-btn
                        icon
                        color="white"
                        v-bind="attrs"
                        @click="dismiss"
                    >
                        <v-icon>mdi-close</v-icon>
                    </v-btn>
                </template>
            </v-snackbar>
        </v-main>
    </v-app>
</template>

<script>
    import VLocaleSelect from "./VLocaleSelect";
    import {mapGetters, mapMutations} from "vuex";
    import AccountMenu from "./nav/AccountMenu";
    import NavMenu from "./nav/NavMenu";

    export default {
        name: "App",
        components: {NavMenu, AccountMenu, VLocaleSelect},
        props: ['user'],
        data: () => ({
            loaded: false,
            drawer: null,
            userMenuActive: false,
            langMenu: false
        }),
        computed: {
            ...mapGetters('snackbar', {
                show: 'getShow',
                color: 'getColor',
                timeout: 'getTimeout',
                message: 'getMessage'
            }),

            snackbar: {
                get() {
                    return this.show;
                },

                set(val) {
                    return this.setShow(val);
                }
            },

            containerClass() {
                let style = [];

                style.push(this.drawer ? 'with-drawer' : 'without-drawer');

                if(!this.$vuetify.breakpoint.mobile) {
                    style.push('medium-viewport');
                }

                return style;
            }
        },
        mounted() {
            this.$store.dispatch('locale/initLocale')
                .then(() => {
                    this.$store.commit('auth/setUser', this.user);
                    this.loaded = true;
                });
        },
        methods: {
            ...mapMutations('snackbar', [
                'setShow',
                'dismiss'
            ])
        }
    }
</script>

<style scoped>
    .medium-viewport {
        width: 90%;
    }
    .with-drawer, .without-drawer {
        margin-top: -16em !important;
    }
    .with-drawer {
        padding-left: 10px;
        padding-right: 10px;
    }
    .without-drawer {
        padding-left: 10px;
        padding-right: 10px;
    }
    .app-bg {
        height: 300px;
        background: var(--v-primary-base);
    }
    .app-bar {
        height: 80px !important;
    }
    .app-bar.primary {
        border-bottom: 2px solid rgba(255, 255, 255, 0.08) !important;
    }
    .app-bar >>> .v-toolbar__content {
        padding-top: 20px;
    }
    .fixed-height {
        height: 80px !important;
    }
    .lang >>> .v-input__prepend-outer {
        margin-top: 5px !important;
    }
    .logo {
        background-color: #000000;
    }
</style>
